var http = require("http"),
    url = require("url"),
    path = require("path"),
    fs = require("fs"),
    port1 = process.argv[2] || 8888,
    port2 = process.argv[3] || 8889;

function error500(err, response){
    response.writeHead(500, {"Content-Type": "text/plain"});
    response.write(err + "\n");
    response.end();
    return;
}
function error404(response){
    response.writeHead(404, {"Content-Type": "text/plain"});
    response.write("404 Not Found\n");
    response.end();
    return;
}
function writeFile(file, response){
    response.writeHead(200);
    response.write(file, "binary");
    response.end();
}

function createServer(basePath, port, domainName){
    http.createServer(function(request, response) {

        var uri = url.parse(request.url).pathname
            , filename = path.join(process.cwd()+basePath, uri);

        fs.exists(filename, function(exists) {
            if(!exists) {
                return error404(response);
            }

            if (fs.statSync(filename).isDirectory()) filename += '/index.html';

            fs.readFile(filename, "binary", function(err, file) {
                if(err) {
                    return error500(err, response);
                }

                writeFile(file, response);
            });
        });
    }).listen(parseInt(port, 10));

    console.log("Static file server running at\n  => http://" + domainName + ":" + port + "/\n"+
        "Be sure to add host file entries for your domains.\n"+
        "If you've changed the domains or default ports then you will need to modify the index pages to match.\n"+
        "CTRL + C to shutdown");
}

createServer("", port1, "pmmain.local");
createServer("/otherdomain/", port2, "pminner.local");

